package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonUnwrapped;
import io.accumulatenetwork.sdk.protocol.Account;
import io.accumulatenetwork.sdk.protocol.DataEntry;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: AccountType
// UnionValue: DataAccount

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("DataAccount")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class DataAccount implements Account {
	public final AccountType type = AccountType.DATA_ACCOUNT;
	private Url url;
	@JsonUnwrapped
	private AccountAuth accountAuth;
	private DataEntry entry;

    //
	public Url getUrl() {
	    return url;
	}
	public void setUrl(final Url value) {
	    this.url = value;
	}

	public DataAccount url(final Url value) {
	    setUrl(value);
	    return this;
	}
	public DataAccount url(final String value) {
	    setUrl(Url.toAccURL(value));
	    return this;
	}
	public AccountAuth getAccountAuth() {
	    return accountAuth;
	}
	public void setAccountAuth(final AccountAuth value) {
	    this.accountAuth = value;
	}

	public DataAccount accountAuth(final AccountAuth value) {
	    setAccountAuth(value);
	    return this;
	}
	public DataEntry getEntry() {
	    return entry;
	}
	public void setEntry(final DataEntry value) {
	    this.entry = value;
	}

	public DataAccount entry(final DataEntry value) {
	    setEntry(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.url == null)) {
            marshaller.writeUrl(2, this.url);
        }
        if (!(this.accountAuth == null)) {
            marshaller.writeValue(3, accountAuth);
        }
        if (!(this.entry == null)) {
            marshaller.writeValue(4, entry);
        }
        return marshaller.array();
    }
}
